/*
 * JNpp - Java bindings for NPP, to be used with JCuda
 *
 * Copyright (c) 2010-2014 Marco Hutter - http://www.jcuda.org
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

#include "JNpp_common.hpp"

bool initNative(JNIEnv *env, jbyteArray input, Npp8s output[], int size);
bool releaseNative(JNIEnv *env, Npp8s output[], jbyteArray input, int size);

bool initNative(JNIEnv *env, jbyteArray input, Npp8u output[], int size);
bool releaseNative(JNIEnv *env, Npp8u output[], jbyteArray input, int size);

bool initNative(JNIEnv *env, jshortArray input, Npp16s output[], int size);
bool releaseNative(JNIEnv *env, Npp16s output[], jshortArray input, int size);

bool initNative(JNIEnv *env, jshortArray input, Npp16u output[], int size);
bool releaseNative(JNIEnv *env, Npp16u output[], jshortArray input, int size);

bool initNative(JNIEnv *env, jintArray input, Npp32s output[], int size);
bool releaseNative(JNIEnv *env, Npp32s output[], jintArray input, int size);

bool initNative(JNIEnv *env, jintArray input, Npp32u output[], int size);
bool releaseNative(JNIEnv *env, Npp32u output[], jintArray input, int size);

bool initNative(JNIEnv *env, jlongArray input, Npp64s output[], int size);
bool releaseNative(JNIEnv *env, Npp64s output[], jlongArray input, int size);

bool initNative(JNIEnv *env, jlongArray input, Npp64u output[], int size);
bool releaseNative(JNIEnv *env, Npp64u output[], jlongArray input, int size);

bool initNative(JNIEnv *env, jfloatArray input, Npp32f output[], int size);
bool releaseNative(JNIEnv *env, Npp32f output[], jfloatArray input, int size);

bool initNative(JNIEnv *env, jdoubleArray input, Npp64f output[], int size);
bool releaseNative(JNIEnv *env, Npp64f output[], jdoubleArray input, int size);

bool initNative(JNIEnv *env, jobjectArray input, Npp16sc output[], int size);
bool releaseNative(JNIEnv *env, Npp16sc output[], jobjectArray input, int size);

bool initNative(JNIEnv *env, jobjectArray input, Npp32sc output[], int size);
bool releaseNative(JNIEnv *env, Npp32sc output[], jobjectArray input, int size);

bool initNative(JNIEnv *env, jobjectArray input, Npp32fc output[], int size);
bool releaseNative(JNIEnv *env, Npp32fc output[], jobjectArray input, int size);

bool initNative(JNIEnv *env, jobjectArray input, Npp64fc output[], int size);
bool releaseNative(JNIEnv *env, Npp64fc output[], jobjectArray input, int size);
